<?php
/**
* Field Plug for AdsManager
* Author: Thomas PAPIN
* URL:  http://www.joomprod.com
* mail: webmaster@joomprod.com
**/

class AdsManagerGmapPlugin {

	function getListDisplay($contentid,$field)
	{
		return AdsManagerGmapPlugin::getDetailsDisplay($contentid,$field);
	}

	function getDetailsDisplay($contentid,$field)
	{
		global $database;
		$query = "SELECT lat,lng FROM #__adsmanager_fieldgmap ".
				 "WHERE fieldid = $field->fieldid AND contentid = $contentid";
		$fieldid = $field->fieldid;
		$database->setQuery($query);
		$database->loadObject($result );
		if ($result)
		{
			$lat = $result->lat;
			$lng = $result->lng;
			$database->setQuery("SELECT * FROM #__adsmanager_fieldgmap_conf WHERE fieldid = $field->fieldid");
			$database->loadObject($conf);
			$map_width = $conf->map_width;//500;
			$map_height= $conf->map_height;//300;
			$google_key = $conf->google_key;//

			$return = '<div id="map_canvas'.$fieldid.'" style="width: '.$map_width.'px; height: '.$map_height.'px; overflow:hidden;"></div>';
			$return .= '<script charset="windows-1251" src="http://maps.kosmosnimki.ru/api/api.js?key='.$google_key.'"></script>'; 
			$return .= '<script>';
			$return .= 'createFlashMap(document.getElementById("map_canvas'.$fieldid.'"), "maps.kosmosnimki.ru", "Kosmosnimki", function(map)';
			$return .= '{';
			$return .= 'globalFlashMap = map;';
			$return .= 'map.moveTo('.$lat.', '.$lng.', 15);';
			$return .= 'map.setBaseLayer("Карта");';
			$return .= 'map.minimizeTools();';
			$return .= 'map.drawing.addObject({ type: "POINT", coordinates: ['.$lat.', '.$lng.']});';
			$return .= '});';
			$return .= '</script>';
			
			return $return;
		}
	}

	function getFormDisplay($contentid,$field)
	{
		global $database;
		$query = "SELECT lat,lng FROM #__adsmanager_fieldgmap ".
				 "WHERE fieldid = $field->fieldid AND contentid = $contentid";
		$fieldid = $field->fieldid;
		$database->setQuery($query);
		$database->loadObject($result );
		
		$database->setQuery("SELECT * FROM #__adsmanager_fieldgmap_conf WHERE fieldid = $field->fieldid");
		$database->loadObject($conf);
		
		if (isset($result))
		{
			$lat = $result->lat;
			$lng = $result->lng;
		}
		else
		{
			$lat = $conf->lat;//"37.4419";
			$lng = $conf->lng;//" -122.1419";
		}
		$map_width = $conf->map_width;//500;
		$map_height= $conf->map_height;//300;
		$google_key = $conf->google_key;//ABQIAAAAbgp4ITpmNUShfIO_dNHv_BR3Tz62YPXwBIaKJWeQ0jDUesttEhTdqyqafAWvPNs2HRK7lWBo2Yemww

$return = '<script charset="windows-1251" src="http://maps.kosmosnimki.ru/api/api.js?key='.$google_key.'"></script>'; 
$return .= '<p><input name="search2" style="width:400px" id="search_string2" type="text" value="Нижний Новгород">&nbsp;&nbsp;<input id="search_button2" value="Поиск" type="button"></p>';
$return .= '<div id="map_canvas'.$fieldid.'" style="width: '.$map_width.'px; height: '.$map_height.'px; overflow:hidden;"></div><br/>';
$return .= '<input type="hidden" id="gmap_lat'.$fieldid.'" name="gmap_lat'.$fieldid.'" value="'.$lat.'"/>';
$return .= '<input type="hidden" id="gmap_lng'.$fieldid.'" name="gmap_lng'.$fieldid.'" value="'.$lng.'"/>';
$return .= '<b>Если Вы не нашли свой адрес, Вы можете кликнуть по карте для размещения маркера в нужном месте.</b>';
$return .= '<script>';
$return .= 'createFlashMap(document.getElementById("map_canvas'.$fieldid.'"), "maps.kosmosnimki.ru", "Kosmosnimki", function(map) {';
$return .= 'map.moveTo('.$lat.', '.$lng.', 15);';
$return .= 'map.minimizeTools();';
$return .= 'var markers = [];';
$return .= 'map.setHandler("onClick", function() {';			
$return .= 'map.drawing.addObject({ type: "POINT", coordinates: [map.getMouseX(), map.getMouseY()]});';
$return .= 'document.getElementById("gmap_lat'.$fieldid.'").value = map.getMouseX();';
$return .= 'document.getElementById("gmap_lng'.$fieldid.'").value = map.getMouseY(); });';		
$return .= 'map.drawing.setHandler("onAdd", function(o) {	';
$return .= 'map.drawing.forEachObject(function(o2){';
$return .= 'if (o2 != o)';
$return .= ' o2.remove(); }); });';
$return .= 'document.getElementById("search_button2").onclick = function()	{';
$return .= 'map.sendSearchRequest(document.getElementById("search_string2").value, ';
$return .= 'function(results) {';
$return .= 'for (var i = 0; i < markers.length; i++)';
$return .= 'markers[i].remove();';
$return .= 'markers = [];';
$return .= 'for (var key in results) {';
$return .= 'for (var j in results[key]) (function(o) {';
$return .= 'map.moveTo(o.CntrLon, o.CntrLat, 16);';
$return .= 'document.getElementById("gmap_lat'.$fieldid.'").value = o.CntrLon;';
$return .= 'document.getElementById("gmap_lng'.$fieldid.'").value = o.CntrLat;';
$return .= 'var obj = map.addObject({ type: "POINT", coordinates: [o.CntrLon, o.CntrLat] });';
$return .= 'obj.setStyle(';
$return .= '{ marker: { image: "http://maps.kosmosnimki.ru/api/img/marker_flag.png", center: true } },';
$return .= '{ marker: { image: "http://maps.kosmosnimki.ru/api/img/marker_flag_a.png", center: true } }	);';
$return .= 'markers.push(obj);';
$return .= 'obj.enableHoverBalloon(function() {';
$return .= 'var parts = [];';
$return .= 'for (var i = o.Path.length - 1; i >= 0; i--)';
$return .= 'parts.push(o.Path[i].join(" "));';
$return .= 'return parts.join("<br />");';
$return .= '});';
$return .= '})(results[key][j]);}';
$return .= 'if (markers.length == 0)';
$return .= 'alert("Ничего не найдено!");});	}});';
$return .= '</script>';

		return $return;
	}

	function onFormSave($contentid,$fieldid,$update)
	{
		global $database;
		$lat = mosGetParam($_POST,"gmap_lat$fieldid",0);
		$lng = mosGetParam($_POST,"gmap_lng$fieldid",0);
		
		if ($update == 1)
		{
			$query = "DELETE FROM #__adsmanager_fieldgmap WHERE fieldid = $fieldid AND contentid = $contentid";
			$database->setQuery($query);
			$database->query();
			$query = "INSERT INTO #__adsmanager_fieldgmap (`fieldid`,`contentid`,`lat`,`lng`) VALUES ".
				 "($fieldid,$contentid,'$lat','$lng')";	 
			$database->setQuery($query);
			$database->query();
		}
		else
		{
			$query = "INSERT INTO #__adsmanager_fieldgmap (`fieldid`,`contentid`,`lat`,`lng`) VALUES ".
				     "($fieldid,$contentid,'$lat','$lng')";
			$database->setQuery($query);
			$database->query();
		}
	}
	
	function onDelete($directory,$contentid = -1)
	{
		global $database;
		if ($contentid == -1)
			$query = "DELETE FROM #__adsmanager_fieldgmap ".
					"WHERE 1";
		else
			$query = "DELETE FROM #__adsmanager_fieldgmap ".
					"WHERE contentid = $contentid";
		$database->setQuery($query);
		$database->query();
	}
	
	function getEditFieldJavaScriptDisable()
	{
		$return = "elem=getObject('divGMapOptions');";
        $return .= "elem.style.visibility = 'hidden';";
		$return .= "elem.style.display = 'none';";
		$return .= "elem=getObject('gmap_map_width');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('gmap_map_height');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('gmap_lat');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('gmap_lng');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('gmap_google_key');";
		$return .= "elem.setAttribute('mosReq',0);";
		return $return;
	}
	
	function getEditFieldJavaScriptActive()
	{
        $return = "disableAll();";
		$return .= "elem=getObject('divGMapOptions');";
		$return .= "elem.style.visibility = 'visible';";
		$return .= "elem.style.display = 'block';";
		$return .= "elem=getObject('gmap_map_width');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('gmap_map_height');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('gmap_lat');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('gmap_lng');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('gmap_google_key');";
		$return .= "elem.setAttribute('mosReq',1);";
		return $return; 
	}

	function getEditFieldOptions($fieldid)
	{
		global $database;
		$database->setQuery("SELECT * FROM #__adsmanager_fieldgmap_conf WHERE fieldid = '$fieldid'");
		$database->loadObject($row);
		
		$return = "<div id='divGMapOptions'>";
		$return .= "<table class='adminform'>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Map Width</td>";
		$return .= "<td width='20%' align=left><input type='text' id='gmap_map_width' name='gmap_map_width' mosReq=1 mosLabel='Map Width' class='inputbox' value='".@$row->map_width."' /></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Map Height</td>";
		$return .= "<td width='20%' align=left><input type='text' id='gmap_map_height' name='gmap_map_height' mosReq=1 mosLabel='Map Height' class='inputbox' value='".@$row->map_height."' /></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Default Lat</td>";
		$return .= "<td width='20%' align=left><input type='text' id='gmap_lat' name='gmap_lat' mosReq=1 mosLabel='Default Lat' class='inputbox' value='".@$row->lat."' /></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Default Lng</td>";
		$return .= "<td width='20%' align=left><input type='text' id='gmap_lng' name='gmap_lng' mosReq=1 mosLabel='Default Lng' class='inputbox' value='".@$row->lng."' /></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Google Key</td>";
		$return .= "<td width='20%' align=left><input type='text' id='gmap_google_key' name='gmap_google_key' mosReq=1 mosLabel='Google Key' class='inputbox' value='".@$row->google_key."' /></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "</table>";
		$return .= "</div>";
		return $return;
	}

	function saveFieldOptions($fieldid)
	{
		global $database;
		$gmap_map_width = mosGetParam($_POST,"gmap_map_width",0);
		$gmap_map_height = mosGetParam($_POST,"gmap_map_height",0);
		$gmap_lat = mosGetParam($_POST,"gmap_lat",0);
		$gmap_lng = mosGetParam($_POST,"gmap_lng",0);
		$gmap_google_key = mosGetParam($_POST,"gmap_google_key",0);
		$database->setQuery("DELETE FROM #__adsmanager_fieldgmap_conf WHERE fieldid = '$fieldid'");
		$database->query();
		$database->setQuery("INSERT INTO #__adsmanager_fieldgmap_conf VALUES ($fieldid,$gmap_map_width,$gmap_map_height,'$gmap_lat','$gmap_lng','$gmap_google_key')");
		$database->query();
		return;
	}
	
	function getFieldName()
	{
		return "GMap Field";
	}
	
	function install()
	{
		global $database;
		
		$query = "CREATE TABLE IF NOT EXISTS `#__adsmanager_fieldgmap` ( ".
			  "`id` int(10) unsigned NOT NULL auto_increment, ".
			  "`fieldid` int(10) unsigned default NULL, ".
			  "`contentid` int(10) unsigned default NULL, ".
			  "`lat` TEXT default NULL, ".
			  "`lng` TEXT default NULL, ".
			  "PRIMARY KEY  (`id`) ".
			  "); ";
		$database->setQuery($query);
		$database->query();
		
		$query = "CREATE TABLE IF NOT EXISTS `#__adsmanager_fieldgmap_conf` ( ".
			  "`fieldid` int(10) unsigned default NULL, ".
			  "`map_width` int(10) unsigned default '500', ".
			  "`map_height` int(10) unsigned default '300', ".
			  "`lat` VARCHAR( 255 ) default '37.4419', ".
			  "`lng` VARCHAR( 255 ) default '-122.1419', ".
			  "`google_key` TEXT default NULL, ".
			  "PRIMARY KEY  (`fieldid`) ".
			  "); ";
		$database->setQuery($query);
		$database->query();
	}
	
	function uninstall()
	{
		global $database;
		
		$query = "DROP TABLE `#__adsmanager_fieldgmap`";
		$database->setQuery($query);
		$database->query();
		
		$query = "DROP TABLE `#__adsmanager_fieldgmap_conf`";
		$database->setQuery($query);
		$database->query();
	}
}

$plugins["gmap"] = new AdsManagerGmapPlugin();
?>
